import numpy as np
from mpl_toolkits.mplot3d import Axes3D
import matplotlib
import matplotlib.pyplot as plt
matplotlib.use('TKAgg')
import datetime
import time

def hyperbolicPos(Bx,Cx,Cy,Ta,Tb,Tc,z,Vs):
	Tab=Ta-Tb
	Tac=Ta-Tc
	Rab=Tab*Vs
	Rac=Tac*Vs
	c=np.sqrt(Cx**2+Cy**2)
	g=(Rac*(Bx/(Rab+0.00001))-Cx)/(Cy)
	d=-(1-(Bx/(Rab+0.00001))**2+g**2)
	h=(c**2-Rac**2+Rac*Rab*(1-(Bx/(Rab+0.00001))**2))/(2*Cy)
	f=((Rab**2)/4)*((1-(Bx/(Rab+0.00001))**2)**2)-h**2
	e=Bx*(1-(Bx/(Rab+0.0001))**2)-2*g*h
	polyeq = [d,e,f-z**2]
	x=np.roots(polyeq)
	y=[g*x[0]+h,g*x[1]+h]
	return [x,y]



def sameSignal(signal_1,signal_2):
	if(signal_1.tag_id==signal_2.tag_id and signal_1.signal_nmbr == signal_2.signal_nmbr):
		if(signal_1.ut-10<signal_2.ut and signal_1.ut+10>signal_2.ut):
			return True
	return False

def logentryInArray(logentry, logarray):
	for i in range(0,len(logarray)-1):
		if(sameSignal(logentry, logarray[i])):
			return i;
	return False

def makeLogArray(filename):
	f= open(filename, 'r')
	logentries = []
	for line in f:
                try:
                        log=logentry()
                        temp = line.split(',')
                        log.ut=int(temp[1])
                        log.ms=int(temp[2])
                        log.tag_id=int(temp[4])
                        log.signal_nmbr = temp[5]
                        log.SNR=int(temp[6])
                        #log.findOrigin()
                        logentries.append(log)
                except:
                        print "error making log"
	f.close()
	return logentries


def findUniqueEntries(logarray):
	temparray=[]
	for i in range(110000,len(logarray)-1):
		if(not logentryInArray(logarray[i], temparray)):
			temparray.append(logarray[i])
	return temparray


def findForTag(array, id):
        temparray = []
        for element in array:
                if(element.tag_id==id):
                        temparray.append(element)
        return temparray

# clock drift
#



class logentry:
	ut=-1 #unix timestamp
	ms=-1 #timestamp in millsec
	tag_id = -1
	signal_nmbr=-1 #signal ID from origin. cyclic from 0 to 255
	SNR = -1 #strength of signal
	origin = "-1"
	def __init__(self):
		pass	


SN022 = makeLogArray('SN022.txt')
SN025 = makeLogArray('SN025.txt')
SN042 = makeLogArray('SN042.txt')
SN045 = makeLogArray('SN045.txt')


print len(SN022), len(SN025), len(SN042)

totalarray=SN022+SN025+SN042

print len(totalarray)
#uniques = findUniqueEntries(totalarray)
#print len(uniques)






SN022_rev=[]
SN025_rev=[]
SN042_rev=[]

temp=0
sig=0

SN022_ts=[]
SN025_ts=[]
SN042_ts=[]

'''
for i in range(0, len(uniques)):
	if(uniques[i].ut!=1446720300 and uniques[i].ut!=1446722400 and logentryInArray(uniques[i],SN025) and logentryInArray(uniques[i],SN022) and logentryInArray(uniques[i],SN042) and uniques[i].tag_id==36 and uniques[i].tag_id!=0):
		SN022_rev.append(SN022[logentryInArray(uniques[i],SN022)])
                SN042_rev.append(SN042[logentryInArray(uniques[i],SN042)])
                SN025_rev.append(SN025[logentryInArray(uniques[i],SN025)])

print "Unique entries: ", len(uniques)
print "Triple shared entries: ", len(SN022_rev)
'''

tag_id = input("State your fishy business")
SN025 = findForTag(SN025,tag_id)
SN042 = findForTag(SN042,tag_id)
SN022 = findForTag(SN022,tag_id)



for i in range(0, len(SN022)):
	if(logentryInArray(SN022[i],SN025) and logentryInArray(SN022[i],SN042)):
		SN022_rev.append(SN022[logentryInArray(SN022[i],SN022)])
                SN042_rev.append(SN042[logentryInArray(SN022[i],SN042)])
                SN025_rev.append(SN025[logentryInArray(SN022[i],SN025)])


for i in range(0,len(SN022_rev)):
        SN022_ts.append(0.00000001+(0.00000001+SN022_rev[i].ut*1000+SN022_rev[i].ms)/float(1000))
        SN025_ts.append(0.00000001+(0.00000001+SN025_rev[i].ut*1000+SN025_rev[i].ms)/float(1000))
        SN042_ts.append(0.00000001+(0.00000001+SN042_rev[i].ut*1000+SN042_rev[i].ms)/float(1000))

pos = []

for i in range(0, len(SN022_rev)):
        print "tag:", SN022_rev[i].tag_id, "| norsk tid: ",time.ctime(int(SN022_ts[i])), "| depth: ",0.2*float(SN025_rev[i].signal_nmbr) #, "| timestamp_diff:", SN042_rev[i].ut-SN022_rev[i].ut, "ms", " nmbr:",SN025_rev[i].signal_nmbr



'''for heigth: 0.2*float(SN025_rev[i].signal_nmbr)-3'''
#def hyperbolicPos(Bx,Cx,Cy,Ta,Tb,Tc,z,Vs):
for i in range(0,len(SN025_ts)):
        if(SN025_rev[i].tag_id != 6 and SN025_rev[i].tag_id != 5):
                pos.append(hyperbolicPos(44.133,22.79,38.22,SN025_ts[i],SN022_ts[i],SN042_ts[i],0.2*float(SN025_rev[i].signal_nmbr)-3,1482))
        else:
                pos.append(hyperbolicPos(44.133,22.79,38.22,SN025_ts[i],SN022_ts[i],SN042_ts[i],0.2*float(SN025_rev[i].signal_nmbr)-3,1482))
	#print "data", SN025_rev[i].tag_id, pos[i], "tdiff 1 2: ", SN025_rev[i].ms-SN022_rev[i].ms, "  Tdiff 1 3: ", SN042_rev[i].ms-SN022_rev[i].ms

fig = plt.figure()
ax = fig.add_subplot(111)

clockres1 = np.random.uniform(0,0.1,500000)


for i in range(0,len(SN025_ts)):
        if(SN025_rev[i].tag_id>32):
                ax.scatter(pos[i][0][0]+clockres1[i], pos[i][1][0], c='r', marker='o')
                ax.scatter(pos[i][0][1], pos[i][1][1], c='r', marker='^')
        else:
                ax.scatter(pos[i][0][0]+clockres1[i], pos[i][1][0], c='b', marker='o')
                ax.scatter(pos[i][0][1], pos[i][1][1], c='b', marker='^')




circle2=plt.Circle((44.133/2,12.74),25.4777,color='c',fill=False)
fig.gca().add_artist(circle2)
ax.scatter(0,0, c='y', marker='o')
ax.scatter(44.133, 0, c='y', marker='o')
ax.scatter(44.133/2, 38.22, c='y', marker='o')

plt.xlim(-40,70)
plt.ylim(-30,70)

"""
plt.set_xlabel('X')
plt.set_ylabel('Y')

"""
plt.show()		
	
