import numpy as np
import time
import fishData
import algorithm as alg

from mpl_toolkits.mplot3d import Axes3D
import matplotlib
import matplotlib.pyplot as plt
matplotlib.use('TKAgg')

class logentry:
	ut=-1 #unix timestamp
	ms=-1 #timestamp in millsec
	time = -1	
	tag_id = -1
	signal_data=-1 #pressure data from tag
	SNR = -1 #strength of signal
	origin = "-1"
	def __init__(self):
		pass


def makeLogArray(filename):
	f= open(filename, 'r')
	logentries = []
	a=0
	for line in f:
                try:
                        log=logentry()
                        temp = line.split(',')
                        log.ut=int(temp[1])
                        log.ms=int(temp[2])
			log.time = float(temp[1])+float(temp[2])/1000
                        log.tag_id=int(temp[4])
                        log.signal_data = int(temp[5])
                        log.SNR=int(temp[6])
			if(log.signal_data!=255):
 	                       logentries.append(log)
			else:
				a+=1
				print "illegal data", a
                except:
                        print "Encountered invalid logentry"
	f.close()
	return logentries

class recvNode:
	position = [-1,-1]
	logArray = []
	def __init__(self, logfile):
		self.logArray=makeLogArray(logfile)
		self.rev_log=[]
	def appendrev(self,logentry):
		self.rev_log.append(logentry)
	def getLogentry(self, index):
		return self.logArray[index]
	def getLogTime(self, index):
		return self.rev_log[index].time
	def getSNR(self, index):
		return self.rev_log[index].SNR



def sameSignal(signal_1,signal_2):
	if(signal_1.tag_id==signal_2.tag_id and signal_1.signal_data == signal_2.signal_data and signal_1.signal_data!=255):
		if(signal_1.time-0.129<signal_2.time and signal_1.time+0.129>signal_2.time):
			return True
	return False


def logentryInArray(logentry, logarray, startfrom):
	for i in range(startfrom,len(logarray)-1):
		if(logarray[i].ut<logentry.ut-2):
			pass
		elif(sameSignal(logentry, logarray[i])):
			return i
		elif(logarray[i].ut>logentry.ut+5):
			break
	return False

SN042 = recvNode('SN042.txt')
SN042.position=[0,0]

SN022 = recvNode('SN022.txt')
SN022.position=[43.0368,0]

SN025 = recvNode('SN025.txt')
SN025.position=[21.3598,39.2669]

SN045 = recvNode('SN045.txt')
SN045.position=[18.5347,12.9517]

recvNodes= [SN042,SN022,SN025,SN045]


starttime= 2

a_i=0
b_i=0
c_i=0
counter = 0


for i in range(0, len(SN022.logArray)):
	a= logentryInArray(SN022.logArray[i],SN025.logArray,a_i)
	b= logentryInArray(SN022.logArray[i],SN042.logArray,b_i)
	c= logentryInArray(SN022.logArray[i],SN045.logArray,c_i)
		
	if(a and b and c):
		SN022.appendrev(SN022.getLogentry(i))
                SN042.appendrev(SN042.getLogentry(b))
                SN025.appendrev(SN025.getLogentry(a))
		SN045.appendrev(SN045.getLogentry(c))
		a_i = a
		b_i=b
		c_i=c



tag_list = []

for i in range(0, len(SN045.rev_log)):
	if(SN045.rev_log[i].tag_id not in tag_list):
		tag_list.append(SN045.rev_log[i].tag_id)
tag_list.sort()

fishes = {}

hp_positions = [SN042.position, SN022.position, SN025.position, SN045.position]

for tag_id in tag_list:
	fishes[tag_id]=fishData.fish(tag_id,  hp_positions, recvNodes)
	for i in range(0, len(SN045.rev_log)):
		if(SN045.rev_log[i].tag_id==tag_id):
			reception_times = [SN042.getLogTime(i), SN022.getLogTime(i), SN025.getLogTime(i), SN045.getLogTime(i)]
			fishes[tag_id].addReceptionTimes(reception_times)
			fishes[tag_id].addDepthData(-3)
			snrvals=[]
			for u in range(0, 4):
				snrvals.append(recvNodes[u].getSNR(i))			
			fishes[tag_id].addSNRData(snrvals)


for tag_id in tag_list:
	fishes[tag_id].setPositions()


print "Found ", len(SN045.rev_log), " positioning eligible signals between ", time.ctime(SN045.rev_log[0].ut)," and " ,time.ctime(SN045.rev_log[len(SN045.rev_log)-1].ut), "."


'''
fig = plt.figure()
ax = fig.add_subplot(111)


fnr=72
instance = 1
print fishes[fnr].positions

print "length: ", len(fishes[fnr].positions), len(fishes[fnr].r_t), len(fishes[fnr].depth_data)

for det in fishes[fnr].detections:
	if(det.lowestSNR>10):
		ax.scatter(det.posX, det.posY, c='b', marker='o')

circle2=plt.Circle((44.133/2,12.74),25.4777,color='c',fill=False)
fig.gca().add_artist(circle2)
ax.scatter(0,0, c='y', marker='o')
ax.scatter(44.133, 0, c='y', marker='o')
ax.scatter(44.133/2, 38.22, c='y', marker='o')
ax.scatter(44.133/2, 11.395, c='y', marker='o')

plt.show()	
'''
