import logParser as lp

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons
import time
from mpl_toolkits.mplot3d.art3d import juggle_axes

fnr=4







x=[]
y=[]
z=[]
t=[]
snr=[]

fishy= lp.fishes[fnr].detections

detections = {}

fish_list = (lp.tag_list)

for i in range(0,len(lp.fishes[fnr].detections)):
	x.append(lp.fishes[fnr].detections[i].posX)
	y.append(lp.fishes[fnr].detections[i].posY)
	z.append(-lp.fishes[fnr].detections[i].depth)
	t.append(lp.fishes[fnr].detections[i].time)



fig = plt.figure()
ax = fig.add_subplot(111, projection='3d')
plt.subplots_adjust(left=0.30, bottom=0.30)
a0 = 5
f0 = 3
#s = a0*np.sin(2*np.pi*f0*t)
data =  ax.scatter(x, y,z, color='red', marker='o')

#plt.axis([0, 1, -10, 10])


#circle2=plt.Circle((44.133/2,12.74),25.4777,color='c',fill=False)
#fig.gca().add_artist(circle2)


ax.scatter(0,0, c='y', marker='o')
ax.scatter(44.133, 0, c='y', marker='o')
ax.scatter(44.133/2, 38.22, c='y', marker='o')
ax.scatter(44.133/2, 11.395, c='y', marker='o')



axcolor = 'lightgoldenrodyellow'
endtime = plt.axes([0.1, 0.05, 0.65, 0.03], axisbg=axcolor)
starttime = plt.axes([0.1, 0.10, 0.65, 0.03], axisbg=axcolor)
starttime.axes.get_xaxis().set_ticks([])
starttime.axes.get_yaxis().set_ticks([])
endtime.axes.get_xaxis().set_ticks([])
endtime.axes.get_yaxis().set_ticks([])


axstart = plt.axes([0.1, 0.20, 0.65, 0.03], axisbg=axcolor)
axend = plt.axes([0.1, 0.15, 0.65, 0.03], axisbg=axcolor)


start = Slider(axstart, 'Start', t[0], t[len(t)-1], valinit=t[0])
end = Slider(axend, 'End', t[0], t[len(t)-1], valinit=t[len(t)-1])
st = 'From'+time.ctime(int(start.val))
en = 'To'+time.ctime(int(end.val))
	
starttime.text(0.06,0.06,st)
endtime.text(0.06,0.06,en)

def update(val):

	startSet = 0
	endSet=0
	for i in range(0,len(x)):
		if(t[i]>=start.val):
			startSet=i
			break

	for i in range(len(x)-1,-1,-1):
		if(t[i]<=end.val):
			endSet=i
			break
	new_pos=[]
	for i in range(startSet,endSet):
		new_pos.append([x[i],y[i],z[i]])	
	data._offsets3d(x,y,z)
	st = 'From '+time.ctime(int(start.val))
	en = 'To '+time.ctime(int(end.val))
	en = en+"    Currently showing ", endSet-startSet, " signals."		

	starttime.texts[-1].set_text(st)
	endtime.texts[-1].set_text(en)	

	fig.canvas.draw_idle()

start.on_changed(update)
end.on_changed(update)

#resetax = plt.axes([0.8, 0.025, 0.1, 0.04])
#button = Button(resetax, 'Reset', color=axcolor, hovercolor='0.975')


def reset(event):
    start.reset()
    end.reset()
#button.on_clicked(reset)


rax = plt.axes([0.05, 0.3, 0.15, 0.5], axisbg=axcolor)
radio = RadioButtons(rax, fish_list, active=0)


def changeFish(label):
	fnr=int(label)
	for i in range(0,len(x)):
		x.pop()
		y.pop()
		z.pop()
		t.pop()
	
	for i in range(0,len(lp.fishes[fnr].detections)):
		x.append(lp.fishes[fnr].detections[i].posX)
		y.append(lp.fishes[fnr].detections[i].posY)
		z.append(-lp.fishes[fnr].detections[i].depth)
		t.append(lp.fishes[fnr].detections[i].time)	
	start.valmin=t[0]
	start.valmax=t[len(t)-1]
	start.val=t[0]	
	end.valmin=t[0]
	end.valmax=t[len(t)-1]
	end.val=t[len(t)-1]

	fig.canvas.draw_idle()
	update(fnr)
radio.on_clicked(changeFish)

plt.show()
